/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package pos.akuntansi;

import com.ustasoft.component.GeneralFunction;
import java.awt.Component;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import org.jdesktop.swingx.decorator.HighlighterFactory;
import pos.MainForm;

/**
 *
 * @author cak-ust
 */
public class FrmBukuBank extends javax.swing.JInternalFrame {
    private Connection conn;
    private GeneralFunction fn=new GeneralFunction();
    private List lstAkun =new ArrayList();
    /**
     * Creates new form FrmBukuBank
     */
    public FrmBukuBank() {
        initComponents();
    }
    
    public void setConn(Connection c){
        this.conn=c;
    }

    private void udfInitForm(){
        
        jXDatePicker1.setDate(MainForm.tglSkg); jXDatePicker1.setFormats(MainForm.sDateFormat);
        jXDatePicker2.setDate(MainForm.tglSkg); jXDatePicker2.setFormats(MainForm.sDateFormat);
        
        try{
            ResultSet rs=conn.createStatement().executeQuery("select acc_no, coalesce(acc_name,'') as acc_name "
                + "from acc_coa where acc_type in('10', '03') "
                + "and acc_no not in(select distinct sub_acc_of from acc_coa where acc_type in('10', '03') and sub_acc_of is not null) "
                + "order by acc_no");
            lstAkun.clear();
            jComboBox1.removeAllItems();

            while(rs.next()){
                jComboBox1.addItem(rs.getString("acc_name"));
                lstAkun.add(rs.getString("acc_no"));
            }
            rs.close();
        }catch(SQLException se){
            JOptionPane.showMessageDialog(this, se.getMessage());
        }
//        masterTable.getColumn("Nama Item").setPreferredWidth(200);
       udfFilter();
       jXTable1.setHighlighters(HighlighterFactory.createAlternateStriping());
       
    }
    
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jXDatePicker1 = new org.jdesktop.swingx.JXDatePicker();
        jXDatePicker2 = new org.jdesktop.swingx.JXDatePicker();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jXTable1 = new org.jdesktop.swingx.JXTable();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Buku Bank");
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameOpened(evt);
            }
        });
        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(null);

        jLabel1.setText("Dari : ");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(390, 10, 50, 20);

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jPanel1.add(jComboBox1);
        jComboBox1.setBounds(80, 10, 300, 20);

        jLabel2.setText("Bank : ");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(10, 10, 80, 20);
        jPanel1.add(jXDatePicker1);
        jXDatePicker1.setBounds(450, 10, 125, 22);
        jPanel1.add(jXDatePicker2);
        jXDatePicker2.setBounds(655, 10, 125, 22);

        jLabel3.setText("Dari : ");
        jPanel1.add(jLabel3);
        jLabel3.setBounds(595, 10, 50, 20);

        jButton1.setText("Tampilkan");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);
        jButton1.setBounds(790, 10, 120, 23);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 10, 930, 45);

        jXTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Tanggal", "No. Sumber", "Keterangan", "Debet", "Kredit", "Saldo", "JrType"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jXTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane1.setViewportView(jXTable1);

        getContentPane().add(jScrollPane1);
        jScrollPane1.setBounds(10, 55, 930, 370);

        setBounds(0, 0, 961, 463);
    }// </editor-fold>//GEN-END:initComponents

    private void formInternalFrameOpened(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameOpened
        udfInitForm();
    }//GEN-LAST:event_formInternalFrameOpened

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        udfFilter();
    }//GEN-LAST:event_jButton1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private org.jdesktop.swingx.JXDatePicker jXDatePicker1;
    private org.jdesktop.swingx.JXDatePicker jXDatePicker2;
    private org.jdesktop.swingx.JXTable jXTable1;
    // End of variables declaration//GEN-END:variables
    
    private void udfFilter(){
        if(jXDatePicker1.getDate()==null || jXDatePicker2.getDate()==null || lstAkun.size()==0 || jComboBox1.getSelectedIndex() <0) return;

        ((DefaultTableModel)jXTable1.getModel()).setNumRows(0);

        String s="select * from fn_acc_rpt_rekap_jurnal_harian(" +
                "'"+new SimpleDateFormat("yyyy-MM-dd").format(jXDatePicker1.getDate())+"', " +
                "'"+new SimpleDateFormat("yyyy-MM-dd").format(jXDatePicker2.getDate())+"', '"+lstAkun.get(jComboBox1.getSelectedIndex()).toString()+"') " +
                "as (acc_no varchar, acc_name varchar, tanggal date, source_no varchar, description varchar," +
                "saldo_aw double precision, debit double precision, credit double precision)";
        int iRow=1;
        double dSaldo=0;
        try {
            ResultSet rs = conn.createStatement().executeQuery(s);
            while(rs.next()){
                if(iRow==1){
                    ((DefaultTableModel)jXTable1.getModel()).addRow(new Object[]{
                        null, //Tanggal
                        "",    //Sumber
                        "",    //Keterangan
                        null,  //Debet
                        null,  //Credit
                        rs.getDouble("saldo_aw"),
                        ""
                    });
                    dSaldo=rs.getDouble("saldo_aw");
                }
                if(rs.getDouble("debit")>0 ||rs.getDouble("credit")>0 ){
                    dSaldo+=rs.getDouble("debit")-rs.getDouble("credit");

                    ((DefaultTableModel)jXTable1.getModel()).addRow(new Object[]{
                        rs.getDate("tanggal"),
                        rs.getString("source_no"),
                        rs.getString("description"),
                        rs.getDouble("debit"),
                        rs.getDouble("credit"),
                        dSaldo

                    });
                }

                iRow++;
            }
            if(jXTable1.getRowCount()>0){
                jXTable1.setRowSelectionInterval(0, 0);
                jXTable1.setModel(fn.autoResizeColWidth(jXTable1, ((DefaultTableModel)jXTable1.getModel())).getModel());
            }
            //cmbTipeAkun.setSelectedIndex(-1);
            rs.close();

        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(this, ex.getMessage(), "Error from udfInitForm", JOptionPane.INFORMATION_MESSAGE);
        }
        
    }

    public class MyRowRenderer extends DefaultTableCellRenderer implements TableCellRenderer{
        SimpleDateFormat dmyFmt=new SimpleDateFormat("dd/MM/yyyy");
        
        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {

            if(value instanceof Date ){
                value=dmyFmt.format(value);
            }else if(value instanceof Double ||value instanceof Integer ||value instanceof Float  ){
                value=fn.dFmt.format(value);
            }
            setFont(table.getFont());
            if(isSelected){
                setBackground(table.getSelectionBackground());
                setForeground(table.getSelectionForeground());
            }else{
                setBackground(table.getBackground());
                setForeground(table.getForeground());
            }

            setValue(value);
            return this;
        }
    }
}
